Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveGenerator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveGenerator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveGenerator.cs	(revision 5177)
@@ -54,5 +54,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       Permutation p = PermutationParameter.ActualValue;
       TranslocationMove[] moves = GenerateMoves(p);
@@ -63,5 +63,5 @@
       }
       CurrentScopeParameter.ActualValue.SubScopes.AddRange(moveScopes);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveHardTabuCriterion.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveHardTabuCriterion.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveHardTabuCriterion.cs	(revision 5177)
@@ -83,5 +83,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemList<IItem> tabuList = TabuListParameter.ActualValue;
       TranslocationMove move = TranslocationMoveParameter.ActualValue;
@@ -177,5 +177,5 @@
       }
       MoveTabuParameter.ActualValue = new BoolValue(isTabu);
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveMaker.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveMaker.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveMaker.cs	(revision 5177)
@@ -63,5 +63,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       TranslocationMove move = TranslocationMoveParameter.ActualValue;
       Permutation permutation = PermutationParameter.ActualValue;
@@ -72,5 +72,5 @@
       quality.Value = moveQuality.Value;
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveSoftTabuCriterion.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveSoftTabuCriterion.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/ThreeOpt/TranslocationMoveSoftTabuCriterion.cs	(revision 5177)
@@ -83,5 +83,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemList<IItem> tabuList = TabuListParameter.ActualValue;
       TranslocationMove move = TranslocationMoveParameter.ActualValue;
@@ -170,5 +170,5 @@
       }
       MoveTabuParameter.ActualValue = new BoolValue(isTabu);
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveGenerator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveGenerator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveGenerator.cs	(revision 5177)
@@ -54,5 +54,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       Permutation p = PermutationParameter.ActualValue;
       InversionMove[] moves = GenerateMoves(p);
@@ -63,5 +63,5 @@
       }
       CurrentScopeParameter.ActualValue.SubScopes.AddRange(moveScopes);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveHardTabuCriterion.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveHardTabuCriterion.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveHardTabuCriterion.cs	(revision 5177)
@@ -84,5 +84,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemList<IItem> tabuList = TabuListParameter.ActualValue;
       InversionMove move = InversionMoveParameter.ActualValue;
@@ -156,5 +156,5 @@
       }
       MoveTabuParameter.ActualValue = new BoolValue(isTabu);
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveMaker.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveMaker.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveMaker.cs	(revision 5177)
@@ -63,5 +63,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       InversionMove move = InversionMoveParameter.ActualValue;
       Permutation permutation = PermutationParameter.ActualValue;
@@ -72,5 +72,5 @@
       quality.Value = moveQuality.Value;
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveSoftTabuCriterion.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveSoftTabuCriterion.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Moves/TwoOpt/InversionMoveSoftTabuCriterion.cs	(revision 5177)
@@ -84,5 +84,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemList<IItem> tabuList = TabuListParameter.ActualValue;
       InversionMove move = InversionMoveParameter.ActualValue;
@@ -157,5 +157,5 @@
       }
       MoveTabuParameter.ActualValue = new BoolValue(isTabu);
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationCrossover.cs	(revision 5177)
@@ -60,7 +60,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       ChildParameter.ActualValue = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationManipulator.cs	(revision 5177)
@@ -54,7 +54,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       Manipulate(RandomParameter.ActualValue, PermutationParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/BoundsChecker.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/BoundsChecker.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/BoundsChecker.cs	(revision 5177)
@@ -80,9 +80,9 @@
     /// <remarks>Calls <see cref="Apply(RealVector, DoubleMatrix)"/>.</remarks>
     /// <inheritdoc select="returns" />
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (RealVectorParameter.ActualValue == null) throw new InvalidOperationException("BoundsChecker: Parameter " + RealVectorParameter.ActualName + " could not be found.");
       if (BoundsParameter.ActualValue == null) throw new InvalidOperationException("BoundsChecker: Parameter " + BoundsParameter.ActualName + " could not be found.");
       Apply(RealVectorParameter.ActualValue, BoundsParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Crossovers/MultiRealVectorCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Crossovers/MultiRealVectorCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Crossovers/MultiRealVectorCrossover.cs	(revision 5177)
@@ -97,7 +97,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one real vector crossover to choose from.");
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Manipulators/MultiRealVectorManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Manipulators/MultiRealVectorManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Manipulators/MultiRealVectorManipulator.cs	(revision 5177)
@@ -88,7 +88,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one real vector manipulator to choose from.");
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Moves/AdditiveMoveGenerator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Moves/AdditiveMoveGenerator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Moves/AdditiveMoveGenerator.cs	(revision 5177)
@@ -63,5 +63,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       RealVector vector = RealVectorParameter.ActualValue;
       AdditiveMove[] moves = GenerateMoves(RandomParameter.ActualValue, vector);
@@ -82,5 +82,5 @@
       }
       CurrentScopeParameter.ActualValue.SubScopes.AddRange(moveScopes);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Moves/AdditiveMoveMaker.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Moves/AdditiveMoveMaker.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Moves/AdditiveMoveMaker.cs	(revision 5177)
@@ -63,5 +63,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       AdditiveMove move = AdditiveMoveParameter.ActualValue;
       RealVector realVector = RealVectorParameter.ActualValue;
@@ -72,5 +72,5 @@
       quality.Value = moveQuality.Value;
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Moves/AdditiveMoveTabuChecker.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Moves/AdditiveMoveTabuChecker.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/Moves/AdditiveMoveTabuChecker.cs	(revision 5177)
@@ -81,5 +81,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemList<IItem> tabuList = TabuListParameter.ActualValue;
       AdditiveMove move = AdditiveMoveParameter.ActualValue;
@@ -106,5 +106,5 @@
       }
       MoveTabuParameter.ActualValue = new BoolValue(isTabu);
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCreator.cs	(revision 5177)
@@ -63,7 +63,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       RealVectorParameter.ActualValue = Create(RandomParameter.ActualValue, LengthParameter.ActualValue, BoundsParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCrossover.cs	(revision 5177)
@@ -65,10 +65,10 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       RealVector result = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
       DoubleMatrix bounds = BoundsParameter.ActualValue;
       if (bounds != null) BoundsChecker.Apply(result, bounds);
       ChildParameter.ActualValue = result;
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorManipulator.cs	(revision 5177)
@@ -59,10 +59,10 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       RealVector vector = RealVectorParameter.ActualValue;
       Manipulate(RandomParameter.ActualValue, vector);
       DoubleMatrix bounds = BoundsParameter.ActualValue;
       if (bounds != null) BoundsChecker.Apply(vector, bounds);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCreator.cs	(revision 5177)
@@ -63,7 +63,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       StrategyParameterParameter.ActualValue = UniformRandomRealVectorCreator.Apply(RandomParameter.ActualValue, LengthParameter.ActualValue.Value, BoundsParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorCrossover.cs	(revision 5177)
@@ -59,7 +59,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       StrategyParameterParameter.ActualValue = AverageCrossover.Apply(RandomParameter.ActualValue, ParentsParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.RealVectorEncoding/3.3/StrategyParameters/StdDevStrategyVectorManipulator.cs	(revision 5177)
@@ -102,5 +102,5 @@
     /// <remarks>Calls <see cref="OperatorBase.Apply"/> of base class <see cref="OperatorBase"/>.</remarks>
     /// <inheritdoc select="returns"/>
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       RealVector strategyParams = StrategyParameterParameter.ActualValue;
       if (strategyParams != null) { // only apply if there is a strategy vector
@@ -110,5 +110,5 @@
         Apply(random, strategyParams, tau0, tau, BoundsParameter.ActualValue);
       }
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Analyzers/SymbolicExpressionTreeSizeCalculator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Analyzers/SymbolicExpressionTreeSizeCalculator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Analyzers/SymbolicExpressionTreeSizeCalculator.cs	(revision 5177)
@@ -65,8 +65,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       SymbolicExpressionTree tree = SymbolicExpressionTree;
       SymbolicExpressionTreeSize = new DoubleValue(tree.Size);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Creators/SymbolicExpressionTreeCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Creators/SymbolicExpressionTreeCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Creators/SymbolicExpressionTreeCreator.cs	(revision 5177)
@@ -72,8 +72,8 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       SymbolicExpressionTree = Create(Random, SymbolicExpressionGrammar,
         MaxTreeSize, MaxTreeHeight, MaxFunctionDefinitions, MaxFunctionArguments);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Crossovers/SymbolicExpressionTreeCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Crossovers/SymbolicExpressionTreeCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Crossovers/SymbolicExpressionTreeCrossover.cs	(revision 5177)
@@ -61,5 +61,5 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       if (ParentsParameter.ActualValue.Length != 2)
         throw new ArgumentException("Number of parents must be exactly two for symbolic expression tree crossover operators.");
@@ -77,5 +77,5 @@
 
       ChildParameter.ActualValue = result;
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Manipulators/SymbolicExpressionTreeManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Manipulators/SymbolicExpressionTreeManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Manipulators/SymbolicExpressionTreeManipulator.cs	(revision 5177)
@@ -64,5 +64,5 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       SymbolicExpressionTree tree = SymbolicExpressionTreeParameter.ActualValue;
       bool success;
@@ -71,5 +71,5 @@
 
       if (!success) FailedManipulationEvents.Value++;
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs	(revision 5177)
@@ -452,5 +452,5 @@
     #region HeuristicLab interfaces
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       lock (syncRoot) {
         if (executeMethod == null) {
@@ -459,5 +459,5 @@
       }
 
-      var parameters = new List<object>() { this, ExecutionContext };
+      var parameters = new List<object>() { this, context };
       parameters.AddRange(Parameters.Select(p => (object)p));
       return (IOperation)executeMethod.Invoke(null, parameters.ToArray());
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/AlgorithmOperator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/AlgorithmOperator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/AlgorithmOperator.cs	(revision 5177)
@@ -55,8 +55,8 @@
     }
 
-    public override IOperation Apply() {
-      OperationCollection next = new OperationCollection(base.Apply());
+    public override IOperation Apply(IExecutionContext context) {
+      OperationCollection next = new OperationCollection(base.Apply(context));
       if (operatorGraph.InitialOperator != null)
-        next.Insert(0, ExecutionContext.CreateChildOperation(operatorGraph.InitialOperator));
+        next.Insert(0, context.CreateChildOperation(operatorGraph.InitialOperator));
       return next;
     }
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/Assigner.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/Assigner.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/Assigner.cs	(revision 5177)
@@ -54,7 +54,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       LeftSideParameter.ActualValue = (IItem)RightSideParameter.ActualValue.Clone();
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/Comparator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/Comparator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/Comparator.cs	(revision 5177)
@@ -68,5 +68,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       IItem left = LeftSideParameter.ActualValue;
       IItem right = RightSideParameter.ActualValue;
@@ -91,5 +91,5 @@
       }
       ResultParameter.ActualValue = new BoolValue(b);
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/ConditionalBranch.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/ConditionalBranch.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/ConditionalBranch.cs	(revision 5177)
@@ -67,10 +67,10 @@
     }
 
-    public override IOperation Apply() {
-      OperationCollection next = new OperationCollection(base.Apply());
+    public override IOperation Apply(IExecutionContext context) {
+      OperationCollection next = new OperationCollection(base.Apply(context));
       if (ConditionParameter.ActualValue != null && ConditionParameter.ActualValue.Value) {
-        if (TrueBranch != null) next.Insert(0, ExecutionContext.CreateOperation(TrueBranch));
+        if (TrueBranch != null) next.Insert(0, context.CreateOperation(TrueBranch));
       } else {
-        if (FalseBranch != null) next.Insert(0, ExecutionContext.CreateOperation(FalseBranch));
+        if (FalseBranch != null) next.Insert(0, context.CreateOperation(FalseBranch));
       }
       return next;
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/DoubleCounter.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/DoubleCounter.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/DoubleCounter.cs	(revision 5177)
@@ -59,8 +59,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (ValueParameter.ActualValue == null) ValueParameter.ActualValue = new DoubleValue();
       ValueParameter.ActualValue.Value += IncrementParameter.ActualValue.Value;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/IntCounter.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/IntCounter.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/IntCounter.cs	(revision 5177)
@@ -59,8 +59,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (ValueParameter.ActualValue == null) ValueParameter.ActualValue = new IntValue();
       ValueParameter.ActualValue.Value += IncrementParameter.ActualValue.Value;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Operators/3.3/Operator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Operators/3.3/Operator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Operators/3.3/Operator.cs	(revision 5177)
@@ -28,5 +28,5 @@
 namespace HeuristicLab.Operators {
   /// <summary>
-  /// The base class for all operators.
+  /// Base class for operators.
   /// </summary>
   [Item("Operator", "Base class for operators.")]
@@ -43,21 +43,5 @@
     }
 
-    [Storable]
-    private IExecutionContext executionContext;
-    protected IExecutionContext ExecutionContext {
-      get { return executionContext; }
-      private set {
-        if (value != executionContext) {
-          executionContext = value;
-          OnExecutionContextChanged();
-        }
-      }
-    }
-
-    /// <summary>
-    /// Flag whether the current instance has been canceled.
-    /// </summary>
     private bool canceled;
-    /// <inheritdoc/>
     protected bool Canceled {
       get { return canceled; }
@@ -72,6 +56,4 @@
     [Storable]
     private bool breakpoint;
-    /// <inheritdoc/>
-    /// <remarks>Calls <see cref="OnBreakpointChanged"/> in the setter.</remarks>
     public bool Breakpoint {
       get { return breakpoint; }
@@ -91,10 +73,5 @@
       this.canceled = original.canceled;
       this.breakpoint = original.breakpoint;
-      this.executionContext = cloner.Clone<IExecutionContext>(original.executionContext);
     }
-    /// <summary>
-    /// Initializes a new instance of <see cref="OperatorBase"/> setting the breakpoint flag and 
-    /// the canceled flag to <c>false</c> and the name of the operator to the type name. 
-    /// </summary>
     protected Operator()
       : base() {
@@ -123,12 +100,10 @@
     }
 
-    /// <inheritdoc/>
     public virtual IOperation Execute(IExecutionContext context) {
       try {
         Canceled = false;
-        ExecutionContext = context;
         foreach (IParameter param in Parameters)
           param.ExecutionContext = context;
-        IOperation next = Apply();
+        IOperation next = Apply(context);
         OnExecuted();
         return next;
@@ -137,26 +112,13 @@
         foreach (IParameter param in Parameters)
           param.ExecutionContext = null;
-        ExecutionContext = null;
       }
     }
-    /// <inheritdoc/>
-    /// <remarks>Sets property <see cref="Canceled"/> to <c>true</c>.</remarks>
     public void Abort() {
       Canceled = true;
     }
-    /// <summary>
-    /// Performs the current operator on the specified <paramref name="scope"/>.
-    /// </summary>
-    /// <param name="scope">The scope where to execute the operator</param>
-    /// <returns><c>null</c>.</returns>
-    public abstract IOperation Apply();
+    public abstract IOperation Apply(IExecutionContext context);
 
-    protected virtual void OnExecutionContextChanged() { }
     protected virtual void OnCanceledChanged() { }
-    /// <inheritdoc/>
     public event EventHandler BreakpointChanged;
-    /// <summary>
-    /// Fires a new <c>BreakpointChanged</c> event.
-    /// </summary>
     protected virtual void OnBreakpointChanged() {
       if (BreakpointChanged != null) {
@@ -164,9 +126,5 @@
       }
     }
-    /// <inheritdoc/>
     public event EventHandler Executed;
-    /// <summary>
-    /// Fires a new <c>Executed</c> event.
-    /// </summary>
     protected virtual void OnExecuted() {
       if (Executed != null) {
